/**
 * Create a deep clone that is equal by value but different by reference.
 * The clone will have the same prototype as the original with all own properties copied / cloned.
 */
export declare function deepClone<T>(original: T): T;
/**
 * Create a shallow/deep clone to a specific depth.
 * The clone is equal to the original by value but different by reference
 * and will have the same prototype as the original with all own properties copied / cloned.
 */
export declare function deepClone<T>(original: T, depth?: number): T;
