/** Map the values of an array to new values. When no properties are changed, the passed array is returned. */
export declare function map<T>(input: T[], mapping: (value: T, index: number, array: T[]) => T, thisArg?: any): T[];
/** Map the values of an object to new values. When no properties are changed, the passed object is returned. */
export declare function map<T>(input: {
    [key: string]: T;
}, mapping: (prop: T, key: string, object: {
    [key: string]: T;
}) => T, thisArg?: any): {
    [key: string]: T;
};
/** Map the values of an object to new values. When no properties are changed, the passed object is returned. */
export declare function map<T, U>(input: T, mapping: (prop: U, key: string, object: T) => U, thisArg?: any): T;
