import { TrackedMethodCall, Subscribable } from './immutable-interfaces';
/**
 * Get notified when a method of an @Immutable class instance is called and of any changed properties.
 * To use the rxjs observables your project uses, you need to pass the `Observable` class.
 */
export declare function observeImmutable<T, O extends Subscribable<TrackedMethodCall<T>>, C extends {
    new (): O;
}>(instance: T, observableClass: C): O;
/**
 * Get notified when a method of an @Immutable class instance is called and of any changed properties.
 */
export declare function observeImmutable<T>(instance: T): Subscribable<TrackedMethodCall<T>>;
