/**
 * Abstract base class for state action branches of an {@link ImmutableStateStore}.
 */
export declare abstract class StateActionBranch<StateType> {
    protected readonly initialState: {
        [Branch in keyof StateType]?: StateType[Branch] | undefined;
    };
    constructor({ uses, initialState }: {
        uses: keyof StateType | (keyof StateType)[];
        initialState: {
            [Branch in keyof StateType]?: StateType[Branch] | undefined;
        };
    });
}
