"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepApplyWithReuse = void 0;
var deep_equal_1 = require("./deep-equal");
var utils_1 = require("./utils");
function deepApplyWithReuse(a, b) {
    if (a === b) {
        return a;
    }
    else if (a == null) {
        return b;
    }
    else if (b == null) {
        return b;
    }
    else if (typeof a !== 'object') {
        return b;
    }
    else if (utils_1.isArray(a)) {
        if (!utils_1.isArray(b)) {
            return b;
        }
        var anyValueChanged = a.length !== b.length;
        var clone = new Array(b.length);
        for (var i = 0; i < clone.length; i++) {
            if (deep_equal_1.deepEqual(a[i], b[i])) {
                clone[i] = a[i];
            }
            else {
                anyValueChanged = true;
                clone[i] = b[i];
            }
        }
        return anyValueChanged ? clone : a;
    }
    else {
        var clone = utils_1.objectAssign({}, a);
        var keysA = utils_1.objectKeys(a);
        var keysB = utils_1.objectKeys(b);
        var anyValueChanged = keysA.length !== keysB.length;
        for (var _i = 0, keysB_1 = keysB; _i < keysB_1.length; _i++) {
            var key = keysB_1[_i];
            var newValue = deepApplyWithReuse(a[key], b[key]);
            if (newValue !== a[key]) {
                anyValueChanged = true;
                clone[key] = newValue;
            }
        }
        return anyValueChanged ? clone : a;
    }
}
exports.deepApplyWithReuse = deepApplyWithReuse;

//# sourceMappingURL=deep-apply-with-reuse.js.map
