"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatEqual = void 0;
var utils_1 = require("./utils");
function flatEqual(a, b) {
    if (a === b) {
        return true;
    }
    else if (utils_1.bothEqualNaN(a, b)) {
        return true;
    }
    else if (!a || !b || typeof a !== 'object') {
        return false;
    }
    var keysA = utils_1.objectKeys(a);
    var keysB = utils_1.objectKeys(b);
    return keysA.length === keysB.length && keysA.every(function (key) {
        return a[key] === b[key] || utils_1.bothEqualNaN(a[key], b[key]);
    });
}
exports.flatEqual = flatEqual;

//# sourceMappingURL=flat-equal.js.map
