"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasSharedReferences = void 0;
var utils_1 = require("./utils");
/**
 * Returns true if the passed object contains any object reference more than once.
 */
function hasSharedReferences(object) {
    if (typeof object !== 'object' || object == null) {
        return false;
    }
    return hasSharedRefs(object, []);
}
exports.hasSharedReferences = hasSharedReferences;
/** @internal */
function hasSharedRefs(object, traversed) {
    if (traversed.indexOf(object) >= 0) {
        return true;
    }
    traversed.push(object);
    if (utils_1.isArray(object)) {
        for (var _i = 0, object_1 = object; _i < object_1.length; _i++) {
            var value = object_1[_i];
            if (typeof value === 'object' && value != null && hasSharedRefs(value, traversed)) {
                return true;
            }
        }
    }
    else {
        for (var _a = 0, _b = utils_1.objectKeys(object); _a < _b.length; _a++) {
            var key = _b[_a];
            if (typeof object[key] === 'object' && object[key] != null && hasSharedRefs(object[key], traversed)) {
                return true;
            }
        }
    }
    return false;
}

//# sourceMappingURL=has-shared-references.js.map
