"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.immutableSettings = exports.getSettings = exports.globalSettings = void 0;
var utils_1 = require("./utils");
/** @internal */
exports.globalSettings = {
    checkMutability: true,
    deepFreeze: false
};
/** @internal */
function getSettings(target) {
    if (target) {
        var metadata = utils_1.getImmutableClassMetadata(target);
        return metadata && metadata.settings || exports.globalSettings;
    }
    else {
        return exports.globalSettings;
    }
}
exports.getSettings = getSettings;
function immutableSettings(classOrGlobalSettings, classSettings) {
    if (!classSettings) {
        // global settings
        var settings = classOrGlobalSettings;
        exports.globalSettings.checkMutability = settings.checkMutability;
    }
    else {
        var metadata = utils_1.getImmutableClassMetadata(classOrGlobalSettings);
        if (!metadata) {
            throw new TypeError('Not an immutable class');
        }
        metadata.settings = classSettings;
    }
}
exports.immutableSettings = immutableSettings;

//# sourceMappingURL=immutable-settings.js.map
