"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.map = void 0;
var flat_equal_1 = require("./flat-equal");
var utils_1 = require("./utils");
function map(input, mapFn, thisArg) {
    var hasChanged = false;
    var clone;
    if (utils_1.isArray(input)) {
        clone = utils_1.arraySlice(input);
        var length = input.length;
        for (var index = 0; index < length; index++) {
            var element = input[index];
            var result = mapFn.call(thisArg, element, index, input);
            if (!flat_equal_1.flatEqual(result, element)) {
                hasChanged = true;
                clone[index] = result;
            }
            else {
                clone[index] = element;
            }
        }
    }
    else {
        clone = utils_1.objectAssign(utils_1.objectCreate(utils_1.objectGetPrototypeOf(input)), input);
        var keys = utils_1.objectKeys(input);
        for (var index = 0; index < keys.length; index++) {
            var prop = input[keys[index]];
            var result = mapFn.call(thisArg, prop, keys[index], input);
            if (!flat_equal_1.flatEqual(result, prop)) {
                hasChanged = true;
                clone[keys[index]] = result;
            }
            else {
                clone[keys[index]] = prop;
            }
        }
    }
    return hasChanged ? clone : input;
}
exports.map = map;

//# sourceMappingURL=map.js.map
