"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.traverseObject = void 0;
var utils_1 = require("./utils");
/**
 * Traverses an object and its child objects breadth-first and calls a callback for every object traversed.
 * Objects referenced more than once do not cause the callback to be called multiple times.
 */
function traverseObject(object, callback) {
    if (typeof object !== 'object' || !object)
        return;
    var traversed = new Set();
    var queue = [{ path: [], value: object }];
    do {
        var current = queue.splice(0, 1)[0];
        if (!traversed.has(current.value)) {
            traversed.add(current.value);
            callback(current.value, current.path);
            for (var _i = 0, _a = utils_1.objectKeys(current.value); _i < _a.length; _i++) {
                var key = _a[_i];
                var value = current.value[key];
                if (typeof value === 'object' && value !== null) {
                    queue.push({ path: __spreadArrays(current.path, [key]), value: value });
                }
            }
        }
    } while (queue.length > 0);
}
exports.traverseObject = traverseObject;

//# sourceMappingURL=traverse-object.js.map
