"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withChanges = void 0;
var utils_1 = require("./utils");
function withChanges(original, assignment) {
    if (typeof assignment === 'function') {
        var clone = utils_1.isArray(original)
            ? utils_1.arraySlice(original)
            : utils_1.objectAssign(utils_1.objectCreate(utils_1.objectGetPrototypeOf(original)), original);
        assignment.call(undefined, clone);
        for (var key in clone) {
            if (original[key] !== clone[key]) {
                return clone;
            }
        }
    }
    else {
        for (var key in assignment) {
            if (original[key] !== assignment[key]) {
                if (utils_1.isArray(original)) {
                    return utils_1.objectAssign(utils_1.arraySlice(original), assignment);
                }
                else {
                    return utils_1.objectAssign(utils_1.objectCreate(utils_1.objectGetPrototypeOf(original)), original, assignment);
                }
            }
        }
    }
    return original;
}
exports.withChanges = withChanges;

//# sourceMappingURL=with-changes.js.map
