import { bothEqualNaN, objectKeys } from './utils';
export function flatEqual(a, b) {
    if (a === b) {
        return true;
    }
    else if (bothEqualNaN(a, b)) {
        return true;
    }
    else if (!a || !b || typeof a !== 'object') {
        return false;
    }
    const keysA = objectKeys(a);
    const keysB = objectKeys(b);
    return keysA.length === keysB.length && keysA.every(key => a[key] === b[key] || bothEqualNaN(a[key], b[key]));
}

//# sourceMappingURL=flat-equal.js.map
