import { getImmutableClassMetadata } from './utils';
/** @internal */
export const globalSettings = {
    checkMutability: true,
    deepFreeze: false
};
/** @internal */
export function getSettings(target) {
    if (target) {
        const metadata = getImmutableClassMetadata(target);
        return metadata && metadata.settings || globalSettings;
    }
    else {
        return globalSettings;
    }
}
export function immutableSettings(classOrGlobalSettings, classSettings) {
    if (!classSettings) {
        // global settings
        const settings = classOrGlobalSettings;
        globalSettings.checkMutability = settings.checkMutability;
    }
    else {
        const metadata = getImmutableClassMetadata(classOrGlobalSettings);
        if (!metadata) {
            throw new TypeError('Not an immutable class');
        }
        metadata.settings = classSettings;
    }
}

//# sourceMappingURL=immutable-settings.js.map
