import { arraySlice, isArray, objectAssign, objectCreate, objectGetPrototypeOf } from './utils';
export function withChanges(original, assignment) {
    if (typeof assignment === 'function') {
        const clone = isArray(original)
            ? arraySlice(original)
            : objectAssign(objectCreate(objectGetPrototypeOf(original)), original);
        assignment.call(undefined, clone);
        for (let key in clone) {
            if (original[key] !== clone[key]) {
                return clone;
            }
        }
    }
    else {
        for (let key in assignment) {
            if (original[key] !== assignment[key]) {
                if (isArray(original)) {
                    return objectAssign(arraySlice(original), assignment);
                }
                else {
                    return objectAssign(objectCreate(objectGetPrototypeOf(original)), original, assignment);
                }
            }
        }
    }
    return original;
}

//# sourceMappingURL=with-changes.js.map
